"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var babel_plugin_macros_1 = require("babel-plugin-macros");
var transforms_babel_1 = require("@ts-nameof/transforms-babel");
exports.default = babel_plugin_macros_1.createMacro(nameofMacro);
function nameofMacro(_a) {
    var references = _a.references, state = _a.state, babel = _a.babel;
    var reverseDefault = references.default.slice().reverse();
    reverseDefault.forEach(function (path) {
        var t = babel.types;
        transforms_babel_1.transformNode(t, getPath(), {
            nameofIdentifierName: path.node.name
        });
        function getPath() {
            var parentPath = path.parentPath;
            if (parentPath.type === "CallExpression")
                return parentPath;
            var grandParentPath = parentPath.parentPath;
            if (parentPath.type === "MemberExpression" && grandParentPath.type === "CallExpression")
                return grandParentPath;
            throw new babel_plugin_macros_1.MacroError("[ts-nameof]: Could not find a call expression at path: " + grandParentPath.getSource());
        }
    });
}
//# sourceMappingURL=index.js.map